# *****************************************************************
#
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2018. All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# *****************************************************************
# Load the data
from sklearn.datasets import load_svmlight_file
import argparse

defaultPath = "."
CLI=argparse.ArgumentParser()
CLI.add_argument(
   "--data_path",
   type=str,
   default=defaultPath
)

args = CLI.parse_args()

X,y = load_svmlight_file(args.data_path + "/data/mnist8m.scale")

# Make the train-test split
from sklearn.model_selection import train_test_split
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.25, random_state=42)

# Normalize the data
from sklearn.preprocessing import normalize
X_train = normalize(X_train)
X_test = normalize(X_test)

# Save the sparse matrices
import scipy as sp
sp.sparse.save_npz(args.data_path + "/data/mnist8m.scale.norm.X_train", X_train, compressed=False)
sp.sparse.save_npz(args.data_path + "/data/mnist8m.scale.norm.X_test",  X_test,  compressed=False)

# Save the labels
import numpy as np
np.save(args.data_path + "/data/mnist8m.scale.norm.y_train", y_train)
np.save(args.data_path + "/data/mnist8m.scale.norm.y_test", y_test)

